package com.usky.agbox.service.job;

import com.alibaba.fastjson.JSONObject;
import com.usky.agbox.service.util.HttpClientUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import java.util.HashMap;

@Component
public class patrolAgbox {

    @Value("${agBox.key}")
    private String KEY;
    @Value("${agBox.url}")
    private String URL;

    /**
     * 获取事件编码信息
     * @return
     */
    public JSONObject getEventCode() {
        HashMap map = new HashMap();
        map.put("key", KEY);
        map.put("json", "{\"jsonrpc\":\"2.0\",\"method\":\"getPatrolEventCode\"}");
        String resultString = HttpClientUtils.doPost(URL,map);
        JSONObject resultVO = JSONObject.parseObject(resultString);
        return resultVO;
    }

    /**
     * 获取设备列表信息
     * @return
     */
    public JSONObject getDeviceList() {
        HashMap map = new HashMap();
        map.put("key", KEY);
        map.put("json", "{\"jsonrpc\":\"2.0\",\"method\":\"getDeviceList\"}");
        String resultString = HttpClientUtils.doPost(URL,map);
        JSONObject resultVO = JSONObject.parseObject(resultString);
        return resultVO;
    }

    /**
     * 添加事件信息
     * @return
     */
    public JSONObject addEvent(String requestBody) {
        JSONObject eventVO = JSONObject.parseObject(requestBody);
        HashMap map = new HashMap();
        map.put("key", KEY);
        map.put("json", "{\"jsonrpc\":\"2.0\",\"method\":\"addEvent\",\"params\":{\"deviceId\":\""+eventVO.get("deviceId").toString()+"\"," +
                "\"triggerTime\":\""+eventVO.get("triggerTime").toString()+"\",\"eventCode\":"+eventVO.get("eventCode")+",\"name" +
                "\":\""+eventVO.get("name").toString()+"\",\"certifiedNo\":\""+eventVO.get("certifiedNo").toString()+"\"}}");
        String resultString = HttpClientUtils.doPost(URL,map);
        JSONObject resultVO = JSONObject.parseObject(resultString);
        return resultVO;
    }

    /**
     * 更新心跳信息
     * @return
     */
    public JSONObject updateHeart(String requestBody) {
        JSONObject eventVO = JSONObject.parseObject(requestBody);
        HashMap map = new HashMap();
        map.put("key", KEY);
        map.put("json",
                "{\"jsonrpc\":\"2.0\",\"method\":\"updateHeart\",\"params\":{\"deviceId\":\""+eventVO.get("deviceId").toString()+"\"}}");
        String resultString = HttpClientUtils.doPost(URL,map);
        JSONObject resultVO = JSONObject.parseObject(resultString);
        return resultVO;
    }

    /**
     * 获取事件信息
     * @return
     */
    public JSONObject getEvent(String requestBody) {
        JSONObject eventVO = JSONObject.parseObject(requestBody);
        HashMap map = new HashMap();
        map.put("key", KEY);
        map.put("json", "{\"jsonrpc\":\"2.0\",\"method\":\"getEvent\",\"params\":{\"eventId\":\""+eventVO.get("eventId").toString()+"\"}}");
        String resultString = HttpClientUtils.doPost(URL,map);
        JSONObject resultVO = JSONObject.parseObject(resultString);
        return resultVO;
    }
}
